/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */
import { SMouseEvent } from "@persagy-web/base";
import { STextItem, SGraphItem } from "@persagy-web/graph/lib";
import { SColor, SFont, SPoint, SPainter } from "@persagy-web/draw/lib";


/**
 * 拓扑图派生按钮
 *
 *  @author  韩耀龙 <han_yao_long@163.com>
 */

export class InfoMsg extends SGraphItem {
    /**信息值 */
    InfoValue: STextItem = new STextItem(null);
    /** 信息 key */

    InfoKey: STextItem = new STextItem(null)

    _data: any

    set data(obj: any) {
        this._data = obj;
        this.setInfoKey(obj)
    }
    get data(): any {
        return this._data
    }

    constructor(parent: SGraphItem | null) {
        super(parent);
        this.InfoValue.moveTo(this.InfoKey.width - 10, this.y + 3);
        this.addItem(this.InfoValue)
        this.addItem(this.InfoKey);
    }


    /** 设置key */
    setInfoKey(data: any) {
        const item = this.InfoKey
        if (data.size) {
            item.width = data.size.width;
            item.height = data.size.height;
        }
        item.zOrder = data.style.default.zorder;
        item.text = data.style.default.text;
        item.color = new SColor(data.style.default.color);
        item.font = new SFont("sans-serif", data.style.default.font);
        item.backgroundColor = new SColor(data.style.default.backgroundColor);
    }

    /**
     * 设置信息点值
     *
     * @param val
     */
    setInfoValue(val:string) {
        this.InfoValue.text = val;
    }

    /**
     * 显示key
     */
    showInfoKey(){
        this.InfoKey.visible = !this.InfoKey.visible
    }

    /**
     * 显示value
     */
    showInfoValue(){
        this.InfoValue.visible = !this.InfoValue.visible
    }


    /**
     * Item 绘制操作
     *
     * @param painter   绘画对象
     */
    onDraw(painter: SPainter): void {
        super.onDraw(painter)
    }
}